=begin
#DocuSign REST API

#The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.

OpenAPI spec version: v2.1
Contact: devcenter@docusign.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

=end

require "uri"

module DocuSign_eSign


  class DataFeedApi
    attr_accessor :api_client

    def initialize(api_client = DataFeedApi.default)
      @api_client = api_client
    end

    # Retrieves a Datafeed element by Id.
    # 
    # @param account_id The external account number (int) or account ID Guid.
    # @param data_feed_element_id 
    # @return [nil]
    def get_data_feed_element(account_id, data_feed_element_id)
      get_data_feed_element_with_http_info(account_id, data_feed_element_id)
      return nil
    end

    # Retrieves a Datafeed element by Id.
    # 
    # @param account_id The external account number (int) or account ID Guid.
    # @param data_feed_element_id 
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def get_data_feed_element_with_http_info(account_id, data_feed_element_id)
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: DataFeedApi.get_data_feed_element ..."
      end
      # verify the required parameter 'account_id' is set
      fail ArgumentError, "Missing the required parameter 'account_id' when calling DataFeedApi.get_data_feed_element" if account_id.nil?
      # verify the required parameter 'data_feed_element_id' is set
      fail ArgumentError, "Missing the required parameter 'data_feed_element_id' when calling DataFeedApi.get_data_feed_element" if data_feed_element_id.nil?
      # resource path
      local_var_path = "/v2.1/accounts/{accountId}/data_feeds/data/{dataFeedElementId}".sub('{format}','json').sub('{' + 'accountId' + '}', account_id.to_s).sub('{' + 'dataFeedElementId' + '}', data_feed_element_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DataFeedApi#get_data_feed_element\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end