=begin
#DocuSign REST API

#The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.

OpenAPI spec version: v2.1
Contact: devcenter@docusign.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

=end

require 'date'

module DocuSign_eSign
  class AccountIdentityVerificationWorkflow
    # 
    attr_accessor :default_description

    # 
    attr_accessor :default_name

    # 
    attr_accessor :input_options

    attr_accessor :signature_provider

    # 
    attr_accessor :steps

    # 
    attr_accessor :workflow_id

    # 
    attr_accessor :workflow_resource_key

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'default_description' => :'defaultDescription',
        :'default_name' => :'defaultName',
        :'input_options' => :'inputOptions',
        :'signature_provider' => :'signatureProvider',
        :'steps' => :'steps',
        :'workflow_id' => :'workflowId',
        :'workflow_resource_key' => :'workflowResourceKey'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'default_description' => :'String',
        :'default_name' => :'String',
        :'input_options' => :'Array<AccountIdentityInputOption>',
        :'signature_provider' => :'AccountSignatureProvider',
        :'steps' => :'Array<AccountIdentityVerificationStep>',
        :'workflow_id' => :'String',
        :'workflow_resource_key' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'defaultDescription')
        self.default_description = attributes[:'defaultDescription']
      end

      if attributes.has_key?(:'defaultName')
        self.default_name = attributes[:'defaultName']
      end

      if attributes.has_key?(:'inputOptions')
        if (value = attributes[:'inputOptions']).is_a?(Array)
          self.input_options = value
        end
      end

      if attributes.has_key?(:'signatureProvider')
        self.signature_provider = attributes[:'signatureProvider']
      end

      if attributes.has_key?(:'steps')
        if (value = attributes[:'steps']).is_a?(Array)
          self.steps = value
        end
      end

      if attributes.has_key?(:'workflowId')
        self.workflow_id = attributes[:'workflowId']
      end

      if attributes.has_key?(:'workflowResourceKey')
        self.workflow_resource_key = attributes[:'workflowResourceKey']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          default_description == o.default_description &&
          default_name == o.default_name &&
          input_options == o.input_options &&
          signature_provider == o.signature_provider &&
          steps == o.steps &&
          workflow_id == o.workflow_id &&
          workflow_resource_key == o.workflow_resource_key
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [default_description, default_name, input_options, signature_provider, steps, workflow_id, workflow_resource_key].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = DocuSign_eSign.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
