=begin
#DocuSign REST API

#The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.

OpenAPI spec version: v2.1
Contact: devcenter@docusign.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

=end

require 'date'

module DocuSign_eSign
  class ChunkedUploadResponse
    # 
    attr_accessor :checksum

    # 
    attr_accessor :chunked_upload_id

    # 
    attr_accessor :chunked_upload_parts

    # 
    attr_accessor :chunked_upload_uri

    # 
    attr_accessor :committed

    # 
    attr_accessor :expiration_date_time

    # 
    attr_accessor :max_chunked_upload_parts

    # 
    attr_accessor :max_total_size

    # 
    attr_accessor :total_size

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'checksum' => :'checksum',
        :'chunked_upload_id' => :'chunkedUploadId',
        :'chunked_upload_parts' => :'chunkedUploadParts',
        :'chunked_upload_uri' => :'chunkedUploadUri',
        :'committed' => :'committed',
        :'expiration_date_time' => :'expirationDateTime',
        :'max_chunked_upload_parts' => :'maxChunkedUploadParts',
        :'max_total_size' => :'maxTotalSize',
        :'total_size' => :'totalSize'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'checksum' => :'String',
        :'chunked_upload_id' => :'String',
        :'chunked_upload_parts' => :'Array<ChunkedUploadPart>',
        :'chunked_upload_uri' => :'String',
        :'committed' => :'String',
        :'expiration_date_time' => :'String',
        :'max_chunked_upload_parts' => :'String',
        :'max_total_size' => :'String',
        :'total_size' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'checksum')
        self.checksum = attributes[:'checksum']
      end

      if attributes.has_key?(:'chunkedUploadId')
        self.chunked_upload_id = attributes[:'chunkedUploadId']
      end

      if attributes.has_key?(:'chunkedUploadParts')
        if (value = attributes[:'chunkedUploadParts']).is_a?(Array)
          self.chunked_upload_parts = value
        end
      end

      if attributes.has_key?(:'chunkedUploadUri')
        self.chunked_upload_uri = attributes[:'chunkedUploadUri']
      end

      if attributes.has_key?(:'committed')
        self.committed = attributes[:'committed']
      end

      if attributes.has_key?(:'expirationDateTime')
        self.expiration_date_time = attributes[:'expirationDateTime']
      end

      if attributes.has_key?(:'maxChunkedUploadParts')
        self.max_chunked_upload_parts = attributes[:'maxChunkedUploadParts']
      end

      if attributes.has_key?(:'maxTotalSize')
        self.max_total_size = attributes[:'maxTotalSize']
      end

      if attributes.has_key?(:'totalSize')
        self.total_size = attributes[:'totalSize']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          checksum == o.checksum &&
          chunked_upload_id == o.chunked_upload_id &&
          chunked_upload_parts == o.chunked_upload_parts &&
          chunked_upload_uri == o.chunked_upload_uri &&
          committed == o.committed &&
          expiration_date_time == o.expiration_date_time &&
          max_chunked_upload_parts == o.max_chunked_upload_parts &&
          max_total_size == o.max_total_size &&
          total_size == o.total_size
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [checksum, chunked_upload_id, chunked_upload_parts, chunked_upload_uri, committed, expiration_date_time, max_chunked_upload_parts, max_total_size, total_size].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = DocuSign_eSign.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
