=begin
#DocuSign REST API

#The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.

OpenAPI spec version: v2.1
Contact: devcenter@docusign.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

=end

require 'date'

module DocuSign_eSign
  class FeatureSet
    # A complex type that contains alternate currency values that are configured for this plan feature set.
    attr_accessor :currency_feature_set_prices

    # 
    attr_accessor :envelope_fee

    # A unique ID for the feature set.
    attr_accessor :feature_set_id

    # 
    attr_accessor :fixed_fee

    # When set to **true**, indicates that this module is enabled on the account.
    attr_accessor :is21_cfr_part11

    # 
    attr_accessor :is_active

    # Specifies whether the feature set is actively enabled as part of the plan.
    attr_accessor :is_enabled

    # 
    attr_accessor :name

    # An incremental seat cost for seat-based plans. Only valid when isEnabled for the feature set is set to true.
    attr_accessor :seat_fee

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'currency_feature_set_prices' => :'currencyFeatureSetPrices',
        :'envelope_fee' => :'envelopeFee',
        :'feature_set_id' => :'featureSetId',
        :'fixed_fee' => :'fixedFee',
        :'is21_cfr_part11' => :'is21CFRPart11',
        :'is_active' => :'isActive',
        :'is_enabled' => :'isEnabled',
        :'name' => :'name',
        :'seat_fee' => :'seatFee'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'currency_feature_set_prices' => :'Array<CurrencyFeatureSetPrice>',
        :'envelope_fee' => :'String',
        :'feature_set_id' => :'String',
        :'fixed_fee' => :'String',
        :'is21_cfr_part11' => :'String',
        :'is_active' => :'String',
        :'is_enabled' => :'String',
        :'name' => :'String',
        :'seat_fee' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'currencyFeatureSetPrices')
        if (value = attributes[:'currencyFeatureSetPrices']).is_a?(Array)
          self.currency_feature_set_prices = value
        end
      end

      if attributes.has_key?(:'envelopeFee')
        self.envelope_fee = attributes[:'envelopeFee']
      end

      if attributes.has_key?(:'featureSetId')
        self.feature_set_id = attributes[:'featureSetId']
      end

      if attributes.has_key?(:'fixedFee')
        self.fixed_fee = attributes[:'fixedFee']
      end

      if attributes.has_key?(:'is21CFRPart11')
        self.is21_cfr_part11 = attributes[:'is21CFRPart11']
      end

      if attributes.has_key?(:'isActive')
        self.is_active = attributes[:'isActive']
      end

      if attributes.has_key?(:'isEnabled')
        self.is_enabled = attributes[:'isEnabled']
      end

      if attributes.has_key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.has_key?(:'seatFee')
        self.seat_fee = attributes[:'seatFee']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          currency_feature_set_prices == o.currency_feature_set_prices &&
          envelope_fee == o.envelope_fee &&
          feature_set_id == o.feature_set_id &&
          fixed_fee == o.fixed_fee &&
          is21_cfr_part11 == o.is21_cfr_part11 &&
          is_active == o.is_active &&
          is_enabled == o.is_enabled &&
          name == o.name &&
          seat_fee == o.seat_fee
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [currency_feature_set_prices, envelope_fee, feature_set_id, fixed_fee, is21_cfr_part11, is_active, is_enabled, name, seat_fee].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = DocuSign_eSign.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
