=begin
#DocuSign REST API

#The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.

OpenAPI spec version: v2.1
Contact: devcenter@docusign.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

=end

require 'date'

module DocuSign_eSign
  class NewAccountDefinition
    # The account name for the new account.
    attr_accessor :account_name

    attr_accessor :account_settings

    attr_accessor :address_information

    attr_accessor :credit_card_information

    attr_accessor :direct_debit_processor_information

    # The code that identifies the billing plan groups and plans for the new account.
    attr_accessor :distributor_code

    # The password for the distributorCode.
    attr_accessor :distributor_password

    # 
    attr_accessor :envelope_partition_id

    attr_accessor :initial_user

    # 
    attr_accessor :payment_method

    attr_accessor :payment_processor_information

    attr_accessor :plan_information

    attr_accessor :referral_information

    attr_accessor :social_account_information

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'account_name' => :'accountName',
        :'account_settings' => :'accountSettings',
        :'address_information' => :'addressInformation',
        :'credit_card_information' => :'creditCardInformation',
        :'direct_debit_processor_information' => :'directDebitProcessorInformation',
        :'distributor_code' => :'distributorCode',
        :'distributor_password' => :'distributorPassword',
        :'envelope_partition_id' => :'envelopePartitionId',
        :'initial_user' => :'initialUser',
        :'payment_method' => :'paymentMethod',
        :'payment_processor_information' => :'paymentProcessorInformation',
        :'plan_information' => :'planInformation',
        :'referral_information' => :'referralInformation',
        :'social_account_information' => :'socialAccountInformation'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'account_name' => :'String',
        :'account_settings' => :'AccountSettingsInformation',
        :'address_information' => :'AccountAddress',
        :'credit_card_information' => :'CreditCardInformation',
        :'direct_debit_processor_information' => :'DirectDebitProcessorInformation',
        :'distributor_code' => :'String',
        :'distributor_password' => :'String',
        :'envelope_partition_id' => :'String',
        :'initial_user' => :'UserInformation',
        :'payment_method' => :'String',
        :'payment_processor_information' => :'PaymentProcessorInformation',
        :'plan_information' => :'PlanInformation',
        :'referral_information' => :'ReferralInformation',
        :'social_account_information' => :'SocialAccountInformation'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'accountName')
        self.account_name = attributes[:'accountName']
      end

      if attributes.has_key?(:'accountSettings')
        self.account_settings = attributes[:'accountSettings']
      end

      if attributes.has_key?(:'addressInformation')
        self.address_information = attributes[:'addressInformation']
      end

      if attributes.has_key?(:'creditCardInformation')
        self.credit_card_information = attributes[:'creditCardInformation']
      end

      if attributes.has_key?(:'directDebitProcessorInformation')
        self.direct_debit_processor_information = attributes[:'directDebitProcessorInformation']
      end

      if attributes.has_key?(:'distributorCode')
        self.distributor_code = attributes[:'distributorCode']
      end

      if attributes.has_key?(:'distributorPassword')
        self.distributor_password = attributes[:'distributorPassword']
      end

      if attributes.has_key?(:'envelopePartitionId')
        self.envelope_partition_id = attributes[:'envelopePartitionId']
      end

      if attributes.has_key?(:'initialUser')
        self.initial_user = attributes[:'initialUser']
      end

      if attributes.has_key?(:'paymentMethod')
        self.payment_method = attributes[:'paymentMethod']
      end

      if attributes.has_key?(:'paymentProcessorInformation')
        self.payment_processor_information = attributes[:'paymentProcessorInformation']
      end

      if attributes.has_key?(:'planInformation')
        self.plan_information = attributes[:'planInformation']
      end

      if attributes.has_key?(:'referralInformation')
        self.referral_information = attributes[:'referralInformation']
      end

      if attributes.has_key?(:'socialAccountInformation')
        self.social_account_information = attributes[:'socialAccountInformation']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          account_name == o.account_name &&
          account_settings == o.account_settings &&
          address_information == o.address_information &&
          credit_card_information == o.credit_card_information &&
          direct_debit_processor_information == o.direct_debit_processor_information &&
          distributor_code == o.distributor_code &&
          distributor_password == o.distributor_password &&
          envelope_partition_id == o.envelope_partition_id &&
          initial_user == o.initial_user &&
          payment_method == o.payment_method &&
          payment_processor_information == o.payment_processor_information &&
          plan_information == o.plan_information &&
          referral_information == o.referral_information &&
          social_account_information == o.social_account_information
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [account_name, account_settings, address_information, credit_card_information, direct_debit_processor_information, distributor_code, distributor_password, envelope_partition_id, initial_user, payment_method, payment_processor_information, plan_information, referral_information, social_account_information].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = DocuSign_eSign.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
