=begin
#DocuSign REST API

#The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.

OpenAPI spec version: v2.1
Contact: devcenter@docusign.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

=end

require 'date'

module DocuSign_eSign
  # An object used to identify the features and attributes of the account being created.
  class PlanInformation
    # Reserved:
    attr_accessor :add_ons

    # Specifies the ISO currency code for the account.
    attr_accessor :currency_code

    # Reserved for DocuSign use only.
    attr_accessor :free_trial_days_override

    # A complex type that sets the feature sets for the account.
    attr_accessor :plan_feature_sets

    # The DocuSign Plan ID for the account.
    attr_accessor :plan_id

    # 
    attr_accessor :recipient_domains

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'add_ons' => :'addOns',
        :'currency_code' => :'currencyCode',
        :'free_trial_days_override' => :'freeTrialDaysOverride',
        :'plan_feature_sets' => :'planFeatureSets',
        :'plan_id' => :'planId',
        :'recipient_domains' => :'recipientDomains'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'add_ons' => :'Array<AddOn>',
        :'currency_code' => :'String',
        :'free_trial_days_override' => :'String',
        :'plan_feature_sets' => :'Array<FeatureSet>',
        :'plan_id' => :'String',
        :'recipient_domains' => :'Array<RecipientDomain>'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'addOns')
        if (value = attributes[:'addOns']).is_a?(Array)
          self.add_ons = value
        end
      end

      if attributes.has_key?(:'currencyCode')
        self.currency_code = attributes[:'currencyCode']
      end

      if attributes.has_key?(:'freeTrialDaysOverride')
        self.free_trial_days_override = attributes[:'freeTrialDaysOverride']
      end

      if attributes.has_key?(:'planFeatureSets')
        if (value = attributes[:'planFeatureSets']).is_a?(Array)
          self.plan_feature_sets = value
        end
      end

      if attributes.has_key?(:'planId')
        self.plan_id = attributes[:'planId']
      end

      if attributes.has_key?(:'recipientDomains')
        if (value = attributes[:'recipientDomains']).is_a?(Array)
          self.recipient_domains = value
        end
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          add_ons == o.add_ons &&
          currency_code == o.currency_code &&
          free_trial_days_override == o.free_trial_days_override &&
          plan_feature_sets == o.plan_feature_sets &&
          plan_id == o.plan_id &&
          recipient_domains == o.recipient_domains
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [add_ons, currency_code, free_trial_days_override, plan_feature_sets, plan_id, recipient_domains].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = DocuSign_eSign.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
