=begin
#DocuSign REST API

#The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.

OpenAPI spec version: v2.1
Contact: devcenter@docusign.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

=end

require 'date'

module DocuSign_eSign
  class Radio
    # 
    attr_accessor :anchor_allow_white_space_in_characters

    attr_accessor :anchor_allow_white_space_in_characters_metadata

    # When set to **true**, the anchor string does not consider case when matching strings in the document. The default value is **true**.
    attr_accessor :anchor_case_sensitive

    attr_accessor :anchor_case_sensitive_metadata

    # Specifies the alignment of anchor tabs with anchor strings. Possible values are **left** or **right**. The default value is **left**.
    attr_accessor :anchor_horizontal_alignment

    attr_accessor :anchor_horizontal_alignment_metadata

    # When set to **true**, this tab is ignored if anchorString is not found in the document.
    attr_accessor :anchor_ignore_if_not_present

    attr_accessor :anchor_ignore_if_not_present_metadata

    # When set to **true**, the anchor string in this tab matches whole words only (strings embedded in other strings are ignored.) The default value is **true**.
    attr_accessor :anchor_match_whole_word

    attr_accessor :anchor_match_whole_word_metadata

    # Anchor text information for a radio button.
    attr_accessor :anchor_string

    attr_accessor :anchor_string_metadata

    # 
    attr_accessor :anchor_tab_processor_version

    attr_accessor :anchor_tab_processor_version_metadata

    # Specifies units of the X and Y offset. Units could be pixels, millimeters, centimeters, or inches.
    attr_accessor :anchor_units

    attr_accessor :anchor_units_metadata

    # Specifies the X axis location of the tab, in anchorUnits, relative to the anchorString.
    attr_accessor :anchor_x_offset

    attr_accessor :anchor_x_offset_metadata

    # Specifies the Y axis location of the tab, in anchorUnits, relative to the anchorString.
    attr_accessor :anchor_y_offset

    attr_accessor :anchor_y_offset_metadata

    # When set to **true**, the information in the tab is bold.
    attr_accessor :bold

    attr_accessor :bold_metadata

    attr_accessor :error_details

    # The font to be used for the tab value. Supported Fonts: Arial, Arial, ArialNarrow, Calibri, CourierNew, Garamond, Georgia, Helvetica,   LucidaConsole, Tahoma, TimesNewRoman, Trebuchet, Verdana, MSGothic, MSMincho, Default.
    attr_accessor :font

    # The font color used for the information in the tab.  Possible values are: Black, BrightBlue, BrightRed, DarkGreen, DarkRed, Gold, Green, NavyBlue, Purple, or White.
    attr_accessor :font_color

    attr_accessor :font_color_metadata

    attr_accessor :font_metadata

    # The font size used for the information in the tab.  Possible values are: Size7, Size8, Size9, Size10, Size11, Size12, Size14, Size16, Size18, Size20, Size22, Size24, Size26, Size28, Size36, Size48, or Size72.
    attr_accessor :font_size

    attr_accessor :font_size_metadata

    # When set to **true**, the information in the tab is italic.
    attr_accessor :italic

    attr_accessor :italic_metadata

    # When set to **true**, the signer cannot change the data of the custom tab.
    attr_accessor :locked

    attr_accessor :locked_metadata

    # Specifies the page number on which the tab is located.
    attr_accessor :page_number

    attr_accessor :page_number_metadata

    # When set to **true**, the signer is required to fill out this tab
    attr_accessor :required

    attr_accessor :required_metadata

    # When set to **true**, the radio button is selected.
    attr_accessor :selected

    attr_accessor :selected_metadata

    # Indicates the envelope status. Valid values are:  * sent - The envelope is sent to the recipients.  * created - The envelope is saved as a draft and can be modified and sent later.
    attr_accessor :status

    attr_accessor :status_metadata

    # The unique identifier for the tab. The tabid can be retrieved with the [ML:GET call].     
    attr_accessor :tab_id

    attr_accessor :tab_id_metadata

    # 
    attr_accessor :tab_order

    attr_accessor :tab_order_metadata

    # When set to **true**, the information in the tab is underlined.
    attr_accessor :underline

    attr_accessor :underline_metadata

    # Specifies the value of the tab. 
    attr_accessor :value

    attr_accessor :value_metadata

    # This indicates the horizontal offset of the object on the page. DocuSign uses 72 DPI when determining position.
    attr_accessor :x_position

    attr_accessor :x_position_metadata

    # This indicates the vertical offset of the object on the page. DocuSign uses 72 DPI when determining position.
    attr_accessor :y_position

    attr_accessor :y_position_metadata

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'anchor_allow_white_space_in_characters' => :'anchorAllowWhiteSpaceInCharacters',
        :'anchor_allow_white_space_in_characters_metadata' => :'anchorAllowWhiteSpaceInCharactersMetadata',
        :'anchor_case_sensitive' => :'anchorCaseSensitive',
        :'anchor_case_sensitive_metadata' => :'anchorCaseSensitiveMetadata',
        :'anchor_horizontal_alignment' => :'anchorHorizontalAlignment',
        :'anchor_horizontal_alignment_metadata' => :'anchorHorizontalAlignmentMetadata',
        :'anchor_ignore_if_not_present' => :'anchorIgnoreIfNotPresent',
        :'anchor_ignore_if_not_present_metadata' => :'anchorIgnoreIfNotPresentMetadata',
        :'anchor_match_whole_word' => :'anchorMatchWholeWord',
        :'anchor_match_whole_word_metadata' => :'anchorMatchWholeWordMetadata',
        :'anchor_string' => :'anchorString',
        :'anchor_string_metadata' => :'anchorStringMetadata',
        :'anchor_tab_processor_version' => :'anchorTabProcessorVersion',
        :'anchor_tab_processor_version_metadata' => :'anchorTabProcessorVersionMetadata',
        :'anchor_units' => :'anchorUnits',
        :'anchor_units_metadata' => :'anchorUnitsMetadata',
        :'anchor_x_offset' => :'anchorXOffset',
        :'anchor_x_offset_metadata' => :'anchorXOffsetMetadata',
        :'anchor_y_offset' => :'anchorYOffset',
        :'anchor_y_offset_metadata' => :'anchorYOffsetMetadata',
        :'bold' => :'bold',
        :'bold_metadata' => :'boldMetadata',
        :'error_details' => :'errorDetails',
        :'font' => :'font',
        :'font_color' => :'fontColor',
        :'font_color_metadata' => :'fontColorMetadata',
        :'font_metadata' => :'fontMetadata',
        :'font_size' => :'fontSize',
        :'font_size_metadata' => :'fontSizeMetadata',
        :'italic' => :'italic',
        :'italic_metadata' => :'italicMetadata',
        :'locked' => :'locked',
        :'locked_metadata' => :'lockedMetadata',
        :'page_number' => :'pageNumber',
        :'page_number_metadata' => :'pageNumberMetadata',
        :'required' => :'required',
        :'required_metadata' => :'requiredMetadata',
        :'selected' => :'selected',
        :'selected_metadata' => :'selectedMetadata',
        :'status' => :'status',
        :'status_metadata' => :'statusMetadata',
        :'tab_id' => :'tabId',
        :'tab_id_metadata' => :'tabIdMetadata',
        :'tab_order' => :'tabOrder',
        :'tab_order_metadata' => :'tabOrderMetadata',
        :'underline' => :'underline',
        :'underline_metadata' => :'underlineMetadata',
        :'value' => :'value',
        :'value_metadata' => :'valueMetadata',
        :'x_position' => :'xPosition',
        :'x_position_metadata' => :'xPositionMetadata',
        :'y_position' => :'yPosition',
        :'y_position_metadata' => :'yPositionMetadata'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'anchor_allow_white_space_in_characters' => :'String',
        :'anchor_allow_white_space_in_characters_metadata' => :'PropertyMetadata',
        :'anchor_case_sensitive' => :'String',
        :'anchor_case_sensitive_metadata' => :'PropertyMetadata',
        :'anchor_horizontal_alignment' => :'String',
        :'anchor_horizontal_alignment_metadata' => :'PropertyMetadata',
        :'anchor_ignore_if_not_present' => :'String',
        :'anchor_ignore_if_not_present_metadata' => :'PropertyMetadata',
        :'anchor_match_whole_word' => :'String',
        :'anchor_match_whole_word_metadata' => :'PropertyMetadata',
        :'anchor_string' => :'String',
        :'anchor_string_metadata' => :'PropertyMetadata',
        :'anchor_tab_processor_version' => :'String',
        :'anchor_tab_processor_version_metadata' => :'PropertyMetadata',
        :'anchor_units' => :'String',
        :'anchor_units_metadata' => :'PropertyMetadata',
        :'anchor_x_offset' => :'String',
        :'anchor_x_offset_metadata' => :'PropertyMetadata',
        :'anchor_y_offset' => :'String',
        :'anchor_y_offset_metadata' => :'PropertyMetadata',
        :'bold' => :'String',
        :'bold_metadata' => :'PropertyMetadata',
        :'error_details' => :'ErrorDetails',
        :'font' => :'String',
        :'font_color' => :'String',
        :'font_color_metadata' => :'PropertyMetadata',
        :'font_metadata' => :'PropertyMetadata',
        :'font_size' => :'String',
        :'font_size_metadata' => :'PropertyMetadata',
        :'italic' => :'String',
        :'italic_metadata' => :'PropertyMetadata',
        :'locked' => :'String',
        :'locked_metadata' => :'PropertyMetadata',
        :'page_number' => :'String',
        :'page_number_metadata' => :'PropertyMetadata',
        :'required' => :'String',
        :'required_metadata' => :'PropertyMetadata',
        :'selected' => :'String',
        :'selected_metadata' => :'PropertyMetadata',
        :'status' => :'String',
        :'status_metadata' => :'PropertyMetadata',
        :'tab_id' => :'String',
        :'tab_id_metadata' => :'PropertyMetadata',
        :'tab_order' => :'String',
        :'tab_order_metadata' => :'PropertyMetadata',
        :'underline' => :'String',
        :'underline_metadata' => :'PropertyMetadata',
        :'value' => :'String',
        :'value_metadata' => :'PropertyMetadata',
        :'x_position' => :'String',
        :'x_position_metadata' => :'PropertyMetadata',
        :'y_position' => :'String',
        :'y_position_metadata' => :'PropertyMetadata'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'anchorAllowWhiteSpaceInCharacters')
        self.anchor_allow_white_space_in_characters = attributes[:'anchorAllowWhiteSpaceInCharacters']
      end

      if attributes.has_key?(:'anchorAllowWhiteSpaceInCharactersMetadata')
        self.anchor_allow_white_space_in_characters_metadata = attributes[:'anchorAllowWhiteSpaceInCharactersMetadata']
      end

      if attributes.has_key?(:'anchorCaseSensitive')
        self.anchor_case_sensitive = attributes[:'anchorCaseSensitive']
      end

      if attributes.has_key?(:'anchorCaseSensitiveMetadata')
        self.anchor_case_sensitive_metadata = attributes[:'anchorCaseSensitiveMetadata']
      end

      if attributes.has_key?(:'anchorHorizontalAlignment')
        self.anchor_horizontal_alignment = attributes[:'anchorHorizontalAlignment']
      end

      if attributes.has_key?(:'anchorHorizontalAlignmentMetadata')
        self.anchor_horizontal_alignment_metadata = attributes[:'anchorHorizontalAlignmentMetadata']
      end

      if attributes.has_key?(:'anchorIgnoreIfNotPresent')
        self.anchor_ignore_if_not_present = attributes[:'anchorIgnoreIfNotPresent']
      end

      if attributes.has_key?(:'anchorIgnoreIfNotPresentMetadata')
        self.anchor_ignore_if_not_present_metadata = attributes[:'anchorIgnoreIfNotPresentMetadata']
      end

      if attributes.has_key?(:'anchorMatchWholeWord')
        self.anchor_match_whole_word = attributes[:'anchorMatchWholeWord']
      end

      if attributes.has_key?(:'anchorMatchWholeWordMetadata')
        self.anchor_match_whole_word_metadata = attributes[:'anchorMatchWholeWordMetadata']
      end

      if attributes.has_key?(:'anchorString')
        self.anchor_string = attributes[:'anchorString']
      end

      if attributes.has_key?(:'anchorStringMetadata')
        self.anchor_string_metadata = attributes[:'anchorStringMetadata']
      end

      if attributes.has_key?(:'anchorTabProcessorVersion')
        self.anchor_tab_processor_version = attributes[:'anchorTabProcessorVersion']
      end

      if attributes.has_key?(:'anchorTabProcessorVersionMetadata')
        self.anchor_tab_processor_version_metadata = attributes[:'anchorTabProcessorVersionMetadata']
      end

      if attributes.has_key?(:'anchorUnits')
        self.anchor_units = attributes[:'anchorUnits']
      end

      if attributes.has_key?(:'anchorUnitsMetadata')
        self.anchor_units_metadata = attributes[:'anchorUnitsMetadata']
      end

      if attributes.has_key?(:'anchorXOffset')
        self.anchor_x_offset = attributes[:'anchorXOffset']
      end

      if attributes.has_key?(:'anchorXOffsetMetadata')
        self.anchor_x_offset_metadata = attributes[:'anchorXOffsetMetadata']
      end

      if attributes.has_key?(:'anchorYOffset')
        self.anchor_y_offset = attributes[:'anchorYOffset']
      end

      if attributes.has_key?(:'anchorYOffsetMetadata')
        self.anchor_y_offset_metadata = attributes[:'anchorYOffsetMetadata']
      end

      if attributes.has_key?(:'bold')
        self.bold = attributes[:'bold']
      end

      if attributes.has_key?(:'boldMetadata')
        self.bold_metadata = attributes[:'boldMetadata']
      end

      if attributes.has_key?(:'errorDetails')
        self.error_details = attributes[:'errorDetails']
      end

      if attributes.has_key?(:'font')
        self.font = attributes[:'font']
      end

      if attributes.has_key?(:'fontColor')
        self.font_color = attributes[:'fontColor']
      end

      if attributes.has_key?(:'fontColorMetadata')
        self.font_color_metadata = attributes[:'fontColorMetadata']
      end

      if attributes.has_key?(:'fontMetadata')
        self.font_metadata = attributes[:'fontMetadata']
      end

      if attributes.has_key?(:'fontSize')
        self.font_size = attributes[:'fontSize']
      end

      if attributes.has_key?(:'fontSizeMetadata')
        self.font_size_metadata = attributes[:'fontSizeMetadata']
      end

      if attributes.has_key?(:'italic')
        self.italic = attributes[:'italic']
      end

      if attributes.has_key?(:'italicMetadata')
        self.italic_metadata = attributes[:'italicMetadata']
      end

      if attributes.has_key?(:'locked')
        self.locked = attributes[:'locked']
      end

      if attributes.has_key?(:'lockedMetadata')
        self.locked_metadata = attributes[:'lockedMetadata']
      end

      if attributes.has_key?(:'pageNumber')
        self.page_number = attributes[:'pageNumber']
      end

      if attributes.has_key?(:'pageNumberMetadata')
        self.page_number_metadata = attributes[:'pageNumberMetadata']
      end

      if attributes.has_key?(:'required')
        self.required = attributes[:'required']
      end

      if attributes.has_key?(:'requiredMetadata')
        self.required_metadata = attributes[:'requiredMetadata']
      end

      if attributes.has_key?(:'selected')
        self.selected = attributes[:'selected']
      end

      if attributes.has_key?(:'selectedMetadata')
        self.selected_metadata = attributes[:'selectedMetadata']
      end

      if attributes.has_key?(:'status')
        self.status = attributes[:'status']
      end

      if attributes.has_key?(:'statusMetadata')
        self.status_metadata = attributes[:'statusMetadata']
      end

      if attributes.has_key?(:'tabId')
        self.tab_id = attributes[:'tabId']
      end

      if attributes.has_key?(:'tabIdMetadata')
        self.tab_id_metadata = attributes[:'tabIdMetadata']
      end

      if attributes.has_key?(:'tabOrder')
        self.tab_order = attributes[:'tabOrder']
      end

      if attributes.has_key?(:'tabOrderMetadata')
        self.tab_order_metadata = attributes[:'tabOrderMetadata']
      end

      if attributes.has_key?(:'underline')
        self.underline = attributes[:'underline']
      end

      if attributes.has_key?(:'underlineMetadata')
        self.underline_metadata = attributes[:'underlineMetadata']
      end

      if attributes.has_key?(:'value')
        self.value = attributes[:'value']
      end

      if attributes.has_key?(:'valueMetadata')
        self.value_metadata = attributes[:'valueMetadata']
      end

      if attributes.has_key?(:'xPosition')
        self.x_position = attributes[:'xPosition']
      end

      if attributes.has_key?(:'xPositionMetadata')
        self.x_position_metadata = attributes[:'xPositionMetadata']
      end

      if attributes.has_key?(:'yPosition')
        self.y_position = attributes[:'yPosition']
      end

      if attributes.has_key?(:'yPositionMetadata')
        self.y_position_metadata = attributes[:'yPositionMetadata']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          anchor_allow_white_space_in_characters == o.anchor_allow_white_space_in_characters &&
          anchor_allow_white_space_in_characters_metadata == o.anchor_allow_white_space_in_characters_metadata &&
          anchor_case_sensitive == o.anchor_case_sensitive &&
          anchor_case_sensitive_metadata == o.anchor_case_sensitive_metadata &&
          anchor_horizontal_alignment == o.anchor_horizontal_alignment &&
          anchor_horizontal_alignment_metadata == o.anchor_horizontal_alignment_metadata &&
          anchor_ignore_if_not_present == o.anchor_ignore_if_not_present &&
          anchor_ignore_if_not_present_metadata == o.anchor_ignore_if_not_present_metadata &&
          anchor_match_whole_word == o.anchor_match_whole_word &&
          anchor_match_whole_word_metadata == o.anchor_match_whole_word_metadata &&
          anchor_string == o.anchor_string &&
          anchor_string_metadata == o.anchor_string_metadata &&
          anchor_tab_processor_version == o.anchor_tab_processor_version &&
          anchor_tab_processor_version_metadata == o.anchor_tab_processor_version_metadata &&
          anchor_units == o.anchor_units &&
          anchor_units_metadata == o.anchor_units_metadata &&
          anchor_x_offset == o.anchor_x_offset &&
          anchor_x_offset_metadata == o.anchor_x_offset_metadata &&
          anchor_y_offset == o.anchor_y_offset &&
          anchor_y_offset_metadata == o.anchor_y_offset_metadata &&
          bold == o.bold &&
          bold_metadata == o.bold_metadata &&
          error_details == o.error_details &&
          font == o.font &&
          font_color == o.font_color &&
          font_color_metadata == o.font_color_metadata &&
          font_metadata == o.font_metadata &&
          font_size == o.font_size &&
          font_size_metadata == o.font_size_metadata &&
          italic == o.italic &&
          italic_metadata == o.italic_metadata &&
          locked == o.locked &&
          locked_metadata == o.locked_metadata &&
          page_number == o.page_number &&
          page_number_metadata == o.page_number_metadata &&
          required == o.required &&
          required_metadata == o.required_metadata &&
          selected == o.selected &&
          selected_metadata == o.selected_metadata &&
          status == o.status &&
          status_metadata == o.status_metadata &&
          tab_id == o.tab_id &&
          tab_id_metadata == o.tab_id_metadata &&
          tab_order == o.tab_order &&
          tab_order_metadata == o.tab_order_metadata &&
          underline == o.underline &&
          underline_metadata == o.underline_metadata &&
          value == o.value &&
          value_metadata == o.value_metadata &&
          x_position == o.x_position &&
          x_position_metadata == o.x_position_metadata &&
          y_position == o.y_position &&
          y_position_metadata == o.y_position_metadata
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [anchor_allow_white_space_in_characters, anchor_allow_white_space_in_characters_metadata, anchor_case_sensitive, anchor_case_sensitive_metadata, anchor_horizontal_alignment, anchor_horizontal_alignment_metadata, anchor_ignore_if_not_present, anchor_ignore_if_not_present_metadata, anchor_match_whole_word, anchor_match_whole_word_metadata, anchor_string, anchor_string_metadata, anchor_tab_processor_version, anchor_tab_processor_version_metadata, anchor_units, anchor_units_metadata, anchor_x_offset, anchor_x_offset_metadata, anchor_y_offset, anchor_y_offset_metadata, bold, bold_metadata, error_details, font, font_color, font_color_metadata, font_metadata, font_size, font_size_metadata, italic, italic_metadata, locked, locked_metadata, page_number, page_number_metadata, required, required_metadata, selected, selected_metadata, status, status_metadata, tab_id, tab_id_metadata, tab_order, tab_order_metadata, underline, underline_metadata, value, value_metadata, x_position, x_position_metadata, y_position, y_position_metadata].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = DocuSign_eSign.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
